-- xItem lua for Checker Wrecker
-- Defines the throw function and xItem data

local function CalcThrowSpeed(mobjtype, dir) -- Wherin we get the base speed based on game speed and throw direcection
	local PROJSPEED = mobjinfo[mobjtype].speed;
	if gamespeed == 0 then
		PROJSPEED = FixedMul(PROJSPEED, FRACUNIT-FRACUNIT/4)
	elseif gamespeed == 2 then
		PROJSPEED = FixedMul(PROJSPEED, FRACUNIT+FRACUNIT/4)
	end
	PROJSPEED = FixedMul(PROJSPEED, mapobjectscale)
	if dir == -1 then
		PROJSPEED = PROJSPEED/8
	end
	return PROJSPEED	
end

local mo, spawnDist, a, ox, oy, ball, initialspeed, finalspeed
local function useGHZBall(p, cmd)
	mo = p.mo
	
	p.kartstuff[k_itemamount] = $-1
	K_PlayAttackTaunt(p.mo)
	
	spawnDist = FixedHypot(mo.radius, mo.radius) + FixedMul(FixedHypot(mobjinfo[MT_GHZBALL].radius, mobjinfo[MT_GHZBALL].radius), mapobjectscale)
	a = mo.angle
	
	initialspeed = CalcThrowSpeed(MT_GHZBALL, 1)
	finalspeed = max(initialspeed, FixedMul(initialspeed, FixedDiv(p.speed, K_GetKartSpeed(p, false))))
	
	ox = P_ReturnThrustX(mo, a, spawnDist)
	oy = P_ReturnThrustY(mo, a, spawnDist)
	
	ball = SpawnWrecker(mo.x + ox + mo.momx, mo.y + oy + mo.momy, mo.z, mo.scale, mo.angle, finalspeed)
	ball.xItemDuration = 1
	K_FlipFromObject(ball, mo)
	ball.target = mo
	
	ball.momz = mo.momz
	if P_IsObjectOnGround(mo) then
		if P_MobjFlip(mo) < 0 then -- I hope this puts it on the ground
			ball.z = ball.ceilingz - ball.height
		else
			ball.z = ball.floorz
		end
		P_TryMove(ball, ball.x, ball.y, true) -- ensure standingslope is set
	end
	ball.lastslope = ball.standingslope
	S_StartSound(mo, ball.info.seesound)
end

-- Wrecker odds adjustment
-- Quad orbis fear me
local offensiverange = 900 -- fracunits, the distiance I consider another player to be hittable with an offensive item
local function wreckerOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	local unchangedodds = newodds
	if unchangedodds == 0 or G_BattleGametype() then return unchangedodds end -- only change odds in brackets where we are obtainable in race mode
	local increasedodds = unchangedodds+10
	local playerahead, playeraheadks
	for p2 in players.iterate do
		if p2.kartstuff[k_position] == p.kartstuff[k_position]-1 then
			playerahead = p2
			playeraheadks = playerahead.kartstuff
		end
	end
	if not playerahead then return unchangedodds end
	local dist = (R_PointToDist2(0, p.mo.x, R_PointToDist2(p.mo.y, p.mo.z, playerahead.mo.y, playerahead.mo.z), playerahead.mo.x) / mapobjectscale)
	if playeraheadks[k_itemamount] > 1 and (playeraheadks[k_itemtype] == KITEM_ORBINAUT or playeraheadks[k_itemtype] == KITEM_JAWZ or playeraheadks[k_itemtype] == KITEM_BANANA) 
		and dist < offensiverange
	then
		return increasedodds
	else
		return unchangedodds
	end
end

--item flags, people making custom items can copy/paste this over to their lua scripts
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot

if xItemLib then
	xItemLib.func.addItem{"CheckerWrecker",
		"Checker Wrecker",
		"K_ITGHZB",
		"K_ISGHZB",
		XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_UNIQUE,
		{ 0, 0, 0, 2, 2, 0, 0, 0, 0, 0 },
		{ 2, 1 },
		false,
		useGHZBall,
		false,
		wreckerOdds,
		false,
		{0, {SPR_GHZB, Q}},
		true,
		nil,
		nil
	}
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_MASTEREMERALD", {
		tipDescription1 = "Throws a familiar wrecking ball",
		tipDescription2 = "Will flatten all players in its path, affected by slopes and bounces off walls",
		tipUsage1 = "Use on downhill spirals for chaos"
	})
end